/*
 * ChartSamplePanel.java
 *
 * <p>Copyright: (c) 2005-2007 by Steema Software SL. All Rights Reserved.</p>
 *
 * <p>Company: Steema Software SL</p>
 */

package demo;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import com.steema.teechart.drawing.Color;
import com.steema.teechart.drawing.Gradient;
import com.steema.teechart.drawing.GradientDirection;
import com.steema.teechart.editors.ChartEditor;
import com.steema.teechart.events.ChartDrawEvent;
import com.steema.teechart.events.ChartPaintAdapter;
import com.steema.teechart.styles.Candle;
import com.steema.teechart.styles.SeriesOHLCPoint;
import com.steema.teechart.themes.ColorPalettes;


/**
 * A sample panel with a TChart 'chart1' instance
 * 
 * @author tom
 */
public class GVChartSamplePanel extends BasicSamplePanel
{

	public GVChart	chart1;


	public Candle	tmpSeries;

	int				counter	= 1;
	boolean			done	= false;
	boolean			nodeal	= false;





	public GVChartSamplePanel()
	{
		super();

	}




	protected void initChart()
	{
		chart1 = new GVChart(this);
		

		chart1.addChartPaintListener(new ChartPaintAdapter()
		{

			public void chartPainted(ChartDrawEvent e)
			{

				;
			}
		});

		chart1.getFooter().setVisible(false);
		chart1.getHeader().setVisible(false);
		chart1.getAspect().setView3D(false);

		Gradient g = chart1.getPanel().getGradient();

		g.setDirection(GradientDirection.VERTICAL);

		// Smooth gray-like colors that adapt correctly to all demos:
		g.setEndColor(new com.steema.teechart.drawing.Color(109, 109, 109));
		g.setMiddleColor(new com.steema.teechart.drawing.Color(149, 202, 255));
		g.setStartColor(new com.steema.teechart.drawing.Color(0, 115, 230));

		g.setVisible(true);

		chart1.getAxes().getLeft().getAxisPen().setWidth(1);
		chart1.getAxes().getBottom().getAxisPen().setWidth(1);

		chart1.getHeader().getFont().setColor(new com.steema.teechart.drawing.Color(226, 226, 226));

		ColorPalettes.applyPalette(chart1.getChart(), 1); // Excel color palette


		//!!chart1.setSize(new Dimension(600, 300));




		chart1.addChartPaintListener(new ChartPaintAdapter()
		{

			public void chartPainted(ChartDrawEvent ae)
			{

				revalidate();
				repaint();

			}
		});


	}




	protected void initComponents()
	{
		super.initComponents();
		initChart();

		// Trick: Show the Chart editor modal dialog when double-clicking the "description" text area
		sampleDescription.addMouseListener(new MouseAdapter()
		{

			public void mouseClicked(MouseEvent e)
			{
				if (e.getClickCount() == 2)
				{
					ChartEditor.editChart(chart1.getChart());
				}
			}

		});
	}




	protected void initGUI()
	{
		super.initGUI();
		setSamplePane(chart1);
	}
}


