package demo;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import com.steema.teechart.Cursor;
import com.steema.teechart.Scroll;
import com.steema.teechart.ScrollMode;
import com.steema.teechart.drawing.Color;
import com.steema.teechart.drawing.Gradient;
import com.steema.teechart.drawing.Point;
import com.steema.teechart.events.ChangeEvent;
import com.steema.teechart.events.ChangeListener;
import com.steema.teechart.events.FrameworkMouseEvent;
import com.steema.teechart.events.ToolMouseListener;
import com.steema.teechart.misc.Utils;
import com.steema.teechart.styles.Candle;
import com.steema.teechart.styles.Series;
import com.steema.teechart.styles.SeriesOHLCPoint;
import com.steema.teechart.styles.StringList;
import com.steema.teechart.themes.ThemesList;
import com.steema.teechart.tools.Annotation;
import com.steema.teechart.tools.CursorTool;
import com.steema.teechart.tools.NearestPoint;
import com.steema.teechart.tools.NearestPointDirection;
import com.steema.teechart.tools.ScrollPager;

/**
 * 
 * @author Steema Software 2011
 */
public class GVScrollPager extends GVChartSamplePanel implements ActionListener, ItemListener, ChangeListener
{

	ScrollPager			tool1;
	Annotation			annoTool;
	CursorTool			xhair;



	//FastLine tmpSeries;

	Annotation			annotate;
	NearestPoint		point;

	boolean				scaled			= false;


	List<Point>			points			= new ArrayList();


	int[]				last3XClicks	= new int[3];
	double[]			last3YClicks	= new double[3];
	StringList			labels;
	boolean				markingLines;
	boolean				markingTrianges;
	boolean				annotationsOn	= false;

	public static Color	toolcolor;


	static int mylabels [][] = {
			{4,12,2009},
			{7,12,2009},
			{8,12,2009},
			{9,12,2009},
			{10,12,2009},
			{11,12,2009},
			{14,12,2009},
			{15,12,2009},
			{16,12,2009},
			{17,12,2009},
			{18,12,2009},
			{21,12,2009},
			{22,12,2009},
			{23,12,2009},
			{24,12,2009},
			{28,12,2009},
			{29,12,2009},
			{30,12,2009},
			{31,12,2009},
			{4,1,2010},
			{5,1,2010},
			{6,1,2010},
			{7,1,2010},
			{8,1,2010},
			{11,1,2010},
			{12,1,2010},
			{13,1,2010},
			{14,1,2010},
			{15,1,2010},
			{19,1,2010},
			{20,1,2010},
			{21,1,2010},
			{22,1,2010},
			{25,1,2010},
			{26,1,2010},
			{27,1,2010},
			{28,1,2010},
			{29,1,2010},
			{1,2,2010},
			{2,2,2010},
			{3,2,2010},
			{4,2,2010},
			{5,2,2010},
			{8,2,2010},
			{9,2,2010},
			{10,2,2010},
			{11,2,2010},
			{12,2,2010},
			{16,2,2010},
			{17,2,2010},
			{18,2,2010},
			{19,2,2010},
			{22,2,2010},
			{23,2,2010},
			{24,2,2010},
			{25,2,2010},
			{26,2,2010},
			{1,3,2010},
			{2,3,2010},
			{3,3,2010},
			{4,3,2010},
			{5,3,2010},
			{8,3,2010},
			{9,3,2010},
			{10,3,2010},
			{11,3,2010},
			{12,3,2010},
			{15,3,2010},
			{16,3,2010},
			{17,3,2010},
			{18,3,2010},
			{19,3,2010},
			{22,3,2010},
			{23,3,2010},
			{24,3,2010},
			{25,3,2010},
			{26,3,2010},
			{29,3,2010},
			{30,3,2010},
			{31,3,2010},
			{1,4,2010},
			{5,4,2010},
			{6,4,2010},
			{7,4,2010},
			{8,4,2010},
			{9,4,2010},
			{12,4,2010},
			{13,4,2010},
			{14,4,2010},
			{15,4,2010},
			{16,4,2010},
			{19,4,2010},
			{20,4,2010},
			{21,4,2010},
			{22,4,2010},
			{23,4,2010},
			{26,4,2010},
			{27,4,2010},
			{28,4,2010},
			{29,4,2010},
			{30,4,2010},
			{3,5,2010},
			{4,5,2010},
			{5,5,2010},
			{6,5,2010},
			{7,5,2010},
			{10,5,2010},
			{11,5,2010},
			{12,5,2010},
			{13,5,2010},
			{14,5,2010},
			{17,5,2010},
			{18,5,2010},
			{19,5,2010},
			{20,5,2010},
			{21,5,2010},
			{24,5,2010},
			{25,5,2010},
			{26,5,2010},
			{27,5,2010},
			{28,5,2010},
			{1,6,2010},
			{2,6,2010},
			{3,6,2010},
			{4,6,2010},
			{7,6,2010},
			{8,6,2010},
			{9,6,2010},
			{10,6,2010},
			{11,6,2010},
			{14,6,2010},
			{15,6,2010},
			{16,6,2010},
			{17,6,2010},
			{18,6,2010},
			{21,6,2010},
			{22,6,2010},
			{23,6,2010},
			{24,6,2010},
			{25,6,2010},
			{28,6,2010},
			{29,6,2010},
			{30,6,2010},
			{1,7,2010},
		
	};
	

	static double mydata [][] = {
			{1100.43,1119.13,1096.52,1105.98},
			{1105.52,1110.72,1100.83,1103.25},
			{1103.04,1103.04,1088.61,1091.94},
			{1091.07,1097.04,1085.89,1095.95},
			{1098.69,1106.25,1098.69,1102.35},
			{1103.96,1108.5,1101.34,1106.41},
			{1107.84,1114.76,1107.84,1114.11},
			{1114.11,1114.11,1105.35,1107.93},
			{1108.61,1116.21,1107.96,1109.18},
			{1106.36,1106.36,1095.88,1096.08},
			{1097.86,1103.74,1093.88,1102.47},
			{1105.31,1117.68,1105.31,1114.05},
			{1114.51,1120.27,1114.51,1118.02},
			{1118.84,1121.58,1116.0,1120.59},
			{1121.08,1126.48,1121.08,1126.48},
			{1127.53,1130.38,1123.51,1127.78},
			{1128.55,1130.38,1126.08,1126.2},
			{1125.53,1126.42,1121.94,1126.42},
			{1126.6,1127.64,1114.81,1115.1},
			{1116.56,1133.87,1116.56,1132.99},
			{1132.66,1136.63,1129.66,1136.52},
			{1135.71,1139.19,1133.95,1137.14},
			{1136.27,1142.46,1131.32,1141.69},
			{1140.52,1145.39,1136.22,1144.98},
			{1145.96,1149.74,1142.02,1146.98},
			{1143.81,1143.81,1131.77,1136.22},
			{1137.31,1148.4,1133.18,1145.68},
			{1145.68,1150.41,1143.8,1148.46},
			{1147.72,1147.77,1131.39,1136.03},
			{1136.03,1150.45,1135.77,1150.23},
			{1147.95,1147.95,1129.25,1138.04},
			{1138.68,1141.58,1114.84,1116.48},
			{1115.49,1115.49,1090.18,1091.76},
			{1092.4,1102.97,1092.4,1096.78},
			{1095.8,1103.69,1089.86,1092.17},
			{1091.94,1099.51,1083.11,1097.5},
			{1096.93,1100.22,1078.46,1084.53},
			{1087.61,1096.45,1071.59,1073.87},
			{1073.89,1089.38,1073.89,1089.19},
			{1090.05,1104.73,1087.96,1103.32},
			{1100.67,1102.72,1093.97,1097.28},
			{1097.25,1097.25,1062.78,1063.11},
			{1064.12,1067.13,1044.5,1066.19},
			{1065.51,1071.2,1056.51,1056.74},
			{1060.06,1079.28,1060.06,1070.52},
			{1069.68,1073.67,1059.34,1068.13},
			{1067.1,1080.04,1060.59,1078.47},
			{1075.95,1077.81,1062.97,1075.51},
			{1079.13,1095.67,1079.13,1094.87},
			{1096.14,1101.03,1094.72,1099.51},
			{1099.03,1108.24,1097.48,1106.75},
			{1105.49,1112.42,1100.8,1109.17},
			{1110.0,1112.29,1105.38,1108.01},
			{1107.49,1108.58,1092.18,1094.6},
			{1095.89,1106.42,1095.5,1105.24},
			{1101.24,1103.5,1086.02,1102.94},
			{1103.1,1107.24,1097.56,1104.49},
			{1105.36,1116.11,1105.36,1115.71},
			{1117.01,1123.46,1116.51,1118.31},
			{1119.36,1125.64,1116.58,1118.79},
			{1119.12,1123.73,1116.66,1122.97},
			{1125.12,1139.38,1125.12,1138.7},
			{1138.4,1141.05,1136.77,1138.5},
			{1137.56,1145.37,1134.9,1140.45},
			{1140.22,1148.26,1140.09,1145.61},
			{1143.96,1150.24,1138.99,1150.24},
			{1151.71,1153.41,1146.97,1149.99},
			{1148.53,1150.98,1141.45,1150.51},
			{1150.83,1160.28,1150.35,1159.46},
			{1159.94,1169.84,1159.94,1166.21},
			{1166.13,1167.77,1161.16,1165.83},
			{1166.68,1169.2,1155.33,1159.9},
			{1157.25,1167.82,1152.88,1165.81},
			{1166.47,1174.72,1163.83,1174.17},
			{1172.7,1173.04,1166.01,1167.72},
			{1170.03,1180.69,1165.09,1165.73},
			{1167.58,1173.93,1161.48,1166.59},
			{1167.71,1174.85,1167.71,1173.22},
			{1173.75,1177.83,1168.92,1173.27},
			{1171.75,1174.56,1165.77,1169.43},
			{1171.23,1181.43,1170.69,1178.1},
			{1178.71,1187.73,1178.71,1187.44},
			{1186.01,1191.8,1182.77,1189.44},
			{1188.23,1189.6,1177.25,1182.45},
			{1181.75,1188.55,1175.12,1186.44},
			{1187.47,1194.66,1187.15,1194.37},
			{1194.94,1199.2,1194.71,1196.48},
			{1195.94,1199.04,1188.82,1197.3},
			{1198.69,1210.65,1198.69,1210.65},
			{1210.77,1213.92,1208.5,1211.67},
			{1210.17,1210.17,1186.77,1192.13},
			{1192.06,1197.87,1183.68,1197.52},
			{1199.04,1208.58,1199.04,1207.17},
			{1207.16,1210.99,1198.85,1205.94},
			{1202.52,1210.27,1190.19,1208.67},
			{1207.87,1217.28,1205.1,1217.28},
			{1217.07,1219.8,1211.07,1212.05},
			{1209.92,1211.38,1181.62,1183.71},
			{1184.59,1195.05,1181.81,1191.36},
			{1193.3,1209.36,1193.3,1206.78},
			{1206.77,1207.99,1186.32,1186.69},
			{1188.58,1205.13,1188.58,1202.26},
			{1197.5,1197.5,1168.12,1173.6},
			{1169.24,1175.95,1158.15,1165.87},
			{1164.38,1167.58,1065.79,1128.15},
			{1127.04,1135.13,1094.15,1110.88},
			{1122.27,1163.85,1122.27,1159.73},
			{1156.39,1170.48,1147.71,1155.79},
			{1155.43,1172.87,1155.43,1171.67},
			{1170.04,1173.57,1156.14,1157.44},
			{1157.19,1157.19,1126.14,1135.68},
			{1136.52,1141.88,1114.96,1136.94},
			{1138.78,1148.66,1117.2,1120.8},
			{1119.57,1124.27,1100.66,1115.05},
			{1107.34,1107.34,1071.58,1071.59},
			{1067.26,1090.16,1055.9,1087.69},
			{1084.78,1089.95,1072.7,1073.65},
			{1067.42,1074.75,1040.78,1074.03},
			{1075.51,1090.75,1065.59,1067.95},
			{1074.27,1103.52,1074.27,1103.06},
			{1102.59,1102.59,1084.78,1089.41},
			{1087.3,1094.77,1069.89,1070.71},
			{1073.01,1098.56,1072.03,1098.38},
			{1098.82,1105.67,1091.81,1102.83},
			{1098.43,1098.43,1060.5,1064.88},
			{1065.84,1071.36,1049.86,1050.47},
			{1050.81,1063.15,1042.17,1062.0},
			{1062.75,1077.74,1052.25,1055.69},
			{1058.77,1087.85,1058.77,1086.84},
			{1082.65,1092.25,1077.12,1091.6},
			{1095.0,1105.91,1089.03,1089.63},
			{1091.21,1115.59,1091.21,1115.23},
			{1114.02,1118.74,1107.13,1114.61},
			{1115.98,1117.72,1105.87,1116.04},
			{1116.16,1121.01,1113.93,1117.51},
			{1122.79,1131.23,1108.24,1113.2},
			{1113.9,1118.5,1094.18,1095.31},
			{1095.57,1099.64,1085.31,1092.04},
			{1090.93,1090.93,1071.6,1073.69},
			{1075.1,1083.56,1067.89,1076.76},
			{1077.5,1082.6,1071.45,1074.57},
			{1071.1,1071.1,1035.18,1041.24},
			{1040.56,1048.08,1028.33,1030.71},
			{1031.1,1033.58,1010.91,1027.37},

};



	public void actionPerformed(ActionEvent e)
	{
		Object source = e.getSource();





	}




	void setCallout(Series aSeries, int aIndex)
	{


		chart1.repaint();

		int firstVisible = tmpSeries.getFirstVisible();
		if (firstVisible > aIndex)
		{
			return;
		}


		SeriesOHLCPoint ohlc = tmpSeries.getOHLCPoint(aIndex);
		double hi = ohlc.getHigh();

		annoTool = new Annotation(chart1.getChart());

		// Re-position annotation callout
		annoTool.getShape().setCustomPosition(true);
		annoTool.getShape().setColor(Color.YELLOW);
		annoTool.getShape().getShadow().setHorizSize(0);
		annoTool.getShape().getShadow().setVertSize(0);

		//annoTool.getShape().getPen().setVisible(false);

		annoTool.setCursor(Cursor.CROSS);
		annoTool.setWidth(28);
		annoTool.setHeight(21);
		annoTool.setLeft(aSeries.calcXPos(aIndex));
		annoTool.setTop(aSeries.calcYPosValue(hi) - 21);
		annoTool.setText("[" + String.format("%4s", "" + aIndex) + "]");


		ToolMouseListener tmpListener = new ToolMouseListener()
		{

			public void toolClicked(FrameworkMouseEvent e)
			{
				JOptionPane.showMessageDialog(null, ((Annotation) e.getSource()).getText());

				// disable chart zoom as we've handled this mouse click ourselves:
				chart1.getChart().setCancelMouse(true);
			}
		};


		annoTool.addToolMouseListener(tmpListener);

		/*
				AnnotationCallout tmpCallout = annoTool.getCallout();		
		        tmpCallout.setVisible(true);
				tmpCallout.setVisible(true);
				tmpCallout.setXPosition(aSeries.calcXPos(aIndex));
				tmpCallout.setYPosition(aSeries.calcYPosValue(hi));
				tmpCallout.setDraw3D(false);
				tmpCallout.setDark3D(false);
		*/




		chart1.repaint();


	}




	public void itemStateChanged(ItemEvent e)
	{

		Object source = e.getItemSelectable();
		boolean isSelected = (e.getStateChange() == ItemEvent.SELECTED);



	}




	/**
	 * Creates a new instance of AxisBreakDemo
	 */
	public GVScrollPager()
	{
		super();

		addComponentListener(new java.awt.event.ComponentAdapter()
		{

			public void componentResized(java.awt.event.ComponentEvent evt)
			{
				scrollPagerDemoResized(evt);
				System.out.println("*********** " + evt.paramString());
				
				java.awt.Dimension d = GVFrame.contentPane.getSize();
				setSize(d);
				setPreferredSize(d);
				chart1.setBounds(Utils.fromLTRB(0, 0, (int)chart1.getParent().getSize().getWidth(), (int)chart1.getParent().getSize().getHeight()-20));
			}
		});

		last3XClicks[0] = 0;
		last3XClicks[1] = 0;
		last3XClicks[2] = 0;
		last3YClicks[0] = 0;
		last3YClicks[1] = 0;
		last3YClicks[2] = 0;



	}




	private void scrollPagerDemoResized(java.awt.event.ComponentEvent evt)
	{
		if (tool1.getSeries() == null)
		{
			tool1.setSeries(tmpSeries);
			ThemesList.applyTheme(tool1.getSubChartTChart().getChart(), 1);
			System.out.println("scrollPagerDemoResized == " +evt.getSource());
		}
	}






	protected void initComponents()
	{
		super.initComponents();

		chart1.getChart().getAspect().setView3D(false);
		chart1.getChart().getLegend().setVisible(false);
		
		
		tmpSeries = new Candle(chart1.getChart());


		tmpSeries.setDownCloseColor(Color.yellow);
		tmpSeries.setUpCloseColor(Color.yellow);

		tmpSeries.setColorEachLine(true);

	

		DateTime dt = new DateTime(2008, 1, 1, 0, 0, 0, 0);
		DateTimeFormatter fmt = DateTimeFormat.forPattern("yyyy.MM.dd");





		tmpSeries.getXValues().setDateTime(false);
		chart1.getAxes().getBottom().getLabels().setAngle(0);




		int count = 0;


		count = 0;
		int sz = mydata.length;
		labels = new StringList(144);

		for (count = 0; count < sz; count++)
		{
			tmpSeries.add(count, mydata[count][0], mydata[count][1], mydata[count][2], mydata[count][3]);
			dt= new DateTime(mylabels[count][2], mylabels[count][1], mylabels[count][0], 0,0,0,0);
			labels.add(fmt.print(dt));
		}

		tmpSeries.setLabels(labels);

		SeriesOHLCPoint ohlc = tmpSeries.getOHLCPoint(3);
		double close = ohlc.getHigh();
		String lable = ohlc.getLabel();

		double dval = tmpSeries.getXValues().getValue(3);

		tmpSeries.getMarks().setVisible(false);
		//tmpSeries.setVerticalAxis(VerticalAxis.BOTH);
		chart1.getPanning().setAllow(ScrollMode.VERTICAL);

		tool1 = new GVScrollPagerImpl(chart1.getChart(), tmpSeries, this);



		Scroll scroll = new Scroll(chart1.getChart());
		scroll.setAllow(ScrollMode.VERTICAL);



		xhair = new CursorTool(chart1.getChart());
		xhair.setSeries(tmpSeries);
		xhair.getPen().setColor(Color.GREEN);
		xhair.getPen().setWidth(3);



		point = new NearestPoint(chart1.getChart());
		point.getBrush().setVisible(true);
		point.getBrush().setColor(tool1.getPointerHighlightColor());
		point.setDrawLine(false);
		point.setSize(6);
		point.setDirection(NearestPointDirection.HORIZONTAL);
		point.setSeries(tmpSeries);
		point.addChangeListener(this);





		ThemesList.applyTheme(chart1.getChart(), 1);


		chart1.addMouseListener(new MouseAdapter()
		{

			public void mouseClicked(MouseEvent e)
			{}
		});

		//chart1.getSeries(0).getMarks().setVisible(true);
		chart1.getWalls().setVisible(false);
		chart1.setBackColor(new Color(100, 100, 100));
		Gradient g = chart1.getPanel().getGradient();
		g.setVisible(false);




	}




	protected void initGUI()
	{
		super.initGUI();
		JPanel tmpPane = getButtonPane();
		{
		}
	}




	public void stateChanged(ChangeEvent e)
	{
		NearestPoint x = (NearestPoint) e.getSource();


		if (point.point > -1)
		{
			if (annotate == null)
				return;

			int index = point.point;
			String lab = labels.getString(index);

			annotate.setText(String.format("%d, %5.4g  %s", index, tmpSeries.getYValues().getValue(point.point), lab));

		}
	}
}

