
package demo;

import com.steema.teechart.Chart;
import com.steema.teechart.ScrollMode;
import com.steema.teechart.events.ChangeEvent;
import com.steema.teechart.events.ChartDrawEvent;
import com.steema.teechart.styles.Candle;
import com.steema.teechart.tools.Annotation;
import com.steema.teechart.tools.ScrollPager;



public class GVScrollPagerImpl extends ScrollPager
{

	public Candle			tmpSeries;
	public Chart			chart1;
	public GVScrollPager	gvScrollPager;




	public void chartEvent(ChartDrawEvent ce)
	{
		super.chartEvent(ce);

		//System.out.println("GVScrollPagerImpl.chartEvent");
		chart1.getPanning().setAllow(ScrollMode.VERTICAL);
	}




	public void dragMoving(ChangeEvent e)
	{

		super.dragMoving(e);




		if (gvScrollPager.annotationsOn)
		{

			for (int i = 0; i < chart1.getTools().size(); i++)
			{
				if (chart1.getTools().getTool(i) instanceof Annotation)
				{
					chart1.getTools().remove(i);
				}
			}

		}

	}




	public void dragFinished(ChangeEvent e)
	{

		super.dragFinished(e);

		chart1.getPanning().setAllow(ScrollMode.VERTICAL);
		
		
		if (gvScrollPager.annotationsOn)
		{
			for (int i = 0; i < chart1.getTools().size(); i++)
			{
				if (chart1.getTools().getTool(i) instanceof Annotation)
				{
					chart1.getTools().remove(i);
				}
			}

		}


	

		
		
		int firstVisible = tmpSeries.getFirstVisible();
		int lastVisible = tmpSeries.getLastVisible() - 1;

		int minVisible = firstVisible;
		int maxVisible = firstVisible;

		for (int i = firstVisible; i <= lastVisible; i++)
		{
			if (tmpSeries.getYValues().getValue(i) < tmpSeries.getYValues().getValue(minVisible))
				minVisible = i;

			if (tmpSeries.getYValues().getValue(i) > tmpSeries.getYValues().getValue(maxVisible))
				maxVisible = i;
		}

		double loy = tmpSeries.getYValues().getValue(minVisible);
		double hiy = tmpSeries.getYValues().getValue(maxVisible);

		//		hiy+=25;
		//		loy-=25;



		chart1.getAxes().getLeft().setMinMax(loy, hiy);




		
		if (gvScrollPager.annotationsOn)
		{
			for (int i = 0; i < 60; i++)
			{
				if (i % 4 == 0)
					gvScrollPager.setCallout(tmpSeries, i);
			}

		}
		
		

	
	}




	public GVScrollPagerImpl(Chart chart1, Candle tmpSeries, GVScrollPager gvScrollPager)
	{
		super(chart1);

		this.tmpSeries = tmpSeries;
		this.chart1 = chart1;
		this.gvScrollPager = gvScrollPager;
		setDivisionRatio(5);
	}
}
